"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _Instructions = require("../Instructions");

var _Quiz = _interopRequireDefault(require("../../../../../records/Quiz"));

var styles = {
  componentId: 'fchim',
  template: function template(theme) {
    return "\n\n.fchim_gasz{box-sizing:border-box;padding-left:".concat(theme.wrapperPadding || 'inherit', ";position:relative;width:100%}\n\n.fchim_gasz:after{clear:both;content:\"\";display:table}\n\n[dir=ltr] .fchim_gasz:after,[dir=rtl] .fchim_gasz:after{clear:both}\n\n.fchim_eWKC{font-size:").concat(theme.textFontSize || 'inherit', "}");
  },
  'wrapper': 'fchim_gasz',
  'text': 'fchim_eWKC'
};
describe('QuizInstructions', function () {
  var testbed = createTestbed(_Instructions.QuizInstructions, {
    quiz: new _Quiz.default({
      id: '3'
    }),
    actions: {
      persistModification: function persistModification() {},
      saveQuizChange: function saveQuizChange() {}
    }
  });
  shouldRenderComponent(testbed, {}, _Instructions.QuizInstructions);
  it('should render quiz instructions preview', function () {
    testbed.render(); // refs aren't working for some reason, so using class finders as a backup
    // not ideal though

    var previewComponentNode = testbed.findChildrenByClass(styles.wrapper)[0];
    expect(previewComponentNode).to.not.be.undefined();
  });
  describe('a11y tests', function () {
    it('should meet a11y standards', function (done) {
      testbed.render();
      testbed.checkA11yStandards(done);
    });
  });
});